



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>socket编程报异常java.io.EOFException</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">socket编程报异常java.io.EOFException</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 08:34:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一个客户端连接服务器的小程序,服务器端可以正常读取客户端发来的数据</p>
<p>但是当客户端关闭时,服务端也关闭了,并且抛出如下的异常:</p>
<div>
<pre class="prettyprint linenums">java.io.EOFException

at java.io.DataInputStream.readUnsignedShort(DataInputStream.java:323)

at java.io.DataInputStream.readUTF(DataInputStream.java:572)

at java.io.DataInputStream.readUTF(DataInputStream.java:547)

at ChatServer.main(ChatServer.java:17) </pre>
</div>
<p>服务器端的代码如下:</p>
<div>
<pre class="prettyprint linenums">import java.io.*;<br />
import java.net.*;<br />
public class ChatServer {<br />
public static void main(String[] args) {<br />
try{<br />
ServerSocket ss=new ServerSocket(7889);<br />
while(true){<br />
Socket s=ss.accept();<br />
DataInputStream dis=new DataInputStream(s.getInputStream());

while(true){<br />
String str=dis.readUTF();<br />
System.out.println(str);<br />
}<br />
}<br />
}catch(IOException e){<br />
e.printStackTrace();<br />
}<br />
}

} </pre>
</div>
<p>产生异常位于: String str=dis.readUTF();</p>
<p>以前也遇到过这种问题，在流传输过程中是不允许被并发访问的。所以数据能接连不断的传过来，其 实有很多人在运行的时候都会碰到EOFException, 然后百思不得其解，去各种论坛问解决方案。其实我想说，这个异常不是必须声明的，也就是说它虽然是异常，但其实是正常运行结束的标志。EOF表示读到了文 件尾（ String str = dis.readUTF(); ，客户端已经断开，后面已经没有内容可以读了），发送结束自然连接也就断开了。</p>
<p>如果这影响到了你socket程序的正确性的话，请静下心来看看自己程序的业务逻辑，而不 要把注意力聚集在发送和接受的方法上。因为我也被这样的bug困扰了1整天，被很多论坛的帖子误解了很多次最后得出的教训。如果在while循环中去 readUTF() ，本质上是没有问题的，有数据来就会读，没有就自动阻塞。那么抛出EOFException一定是因为连接断了还在继续read，什么原因导致连接断了 呢？一定是业务逻辑哪里存在错误，比如NullPoint、 ClassCaseException、ArrayOutofBound，即使程序较大也没关系，最多只要单步调适一次就能很快发现bug并且解决它。</p>
<p>那么是属于哪一种呢？当然是第一种，因为你客户端已经被你断开，所以你应该怎么做呢</p>
<p>你可以捕捉这个客户端断开的异常EOFExcption,然后做你需要的处理,try ... catch（EOFException）{ System.out.println("这是合法的，客户端已经关闭");}</p>
<p>客户端每次在传输完数据后，再传输一个null过去，就行了。不然就报EOF异常。</p>
<p>源文：<a href="http://anwj336.blog.163.com/blog/static/8941520920087732313926/" rel="external nofollow noreferrer">http://anwj336.blog.163.com/blog/static/8941520920087732313926/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1nzz9g.html">ASP&period;NET MVC Anti-XSS方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdwp3z9.html">ant 自动化编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejv3j9.html">解决在VS2015下用C&plus;&plus;开发的DLL在WIN7上无法加载运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e34yzq.html">UICollectionView swift2模版</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zdkxx9.html">WMI入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6zgo8.html">基于Html5的移动端开发框架的研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3yr69.html">Ajax基础详解1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10op39.html">jquery on 动态添加的元素，神奇的bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3x309.html">css笔记18：盒子模型案例分析示范</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m02mgq.html">JSOI2008 最小生成树计数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v3z3o8.html">CSS中zoom&colon;1的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k17x4r9.html">github进行修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1vpr8.html">C&num;解析JSON数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngnd0q.html">windows Oracle DBases auto backUp</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w77g3q.html">PHP glob&lpar;&rpar; 函数用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkjl79.html">&lbrack;js高手之路&rsqb;设计模式系列课程-委托模式实战微博发布功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj74019.html">开源中文分词工具探析（五）：Stanford CoreNLP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgx1yd8.html">bzoj2006 &lbrack;NOI2010&rsqb;超级钢琴 （及其拓展）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960pvyj9.html">解决js数组循环删除出错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xx2z9.html">python练习（-）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pevo78.html">phpMyadmin &sol;scripts&sol;setup&period;php Execute Arbitrary PHP Code Via unserialize Vul Object Injection PMASA-2010-4</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkkwl8.html">XmlReader读取XML</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql7d1e9.html">通往WinDbg的捷径（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pe6kz8.html">Beta版本&mdash;&mdash;第二次冲刺博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn06wj9.html">RBM Formula Deduction</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k46w79.html">JS性能方面--内存管理及ECMAScript5 Object的新属性方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jg7209.html">9 HTML&amp;amp&semi;JS等前端知识系列之Ajax post请求带有token向Django请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2v1gx8.html">C&plus;&plus; STL中vector的内存机制和性能分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2vz2w8.html">添加JavaScrip</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyxk428.html">INADDR&lowbar;ANY</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
